/**
 * Created by Administrator on 2015/8/20.
 */
define(['jquery'],function($){
    var $weekDate,activeDate,$timeLineLis,$event1,$event2,$event3;
    var arrDay = ['日', '一', '二', '三', '四', '五', '六'];
    var initVar = function(){
        var $dateTxt = $('.date-text');
        $weekDate = $('.week-date');
        $weekDate.click(function() {
            var sDate = $(this).data('date');
            activeDate = sDate;
            $(this).addClass('active');
            $weekDate.not(this).removeClass('active');
            var date = new Date(sDate.replace(/(\d{4})(\d{2})(\d{2})/, '$1-$2-$3'));
            $dateTxt.html(date.getFullYear() + '年' + (date.getMonth()+1) + '月' + date.getDate() + '日 星期' + arrDay[date.getDay()]);
            if(window.Android){
                updateSchedule(Android.isComplateDetail(sDate));
            }
        });
        $timeLineLis = $('.time-line > li');
        $event1 = $('.event-type-1','#eventsTemplate');
        $event2 = $event1.siblings('.event-type-2');
        $event3 = $event1.siblings('.event-type-3');
    };

    function updateWeekDate(dateProperties,arrHasEvent,notClick,isAppend){
        if(typeof dateProperties == 'string'){
            var tempDate = new Date(dateProperties.replace(/(\d{4})(\d{2})(\d{2})/,'$1-$2-$3'));
            dateProperties = {
                weekday: tempDate.getDay(),
                year: tempDate.getFullYear(),
                month: tempDate.getMonth() + 1,
                day: tempDate.getDate()
            };
        }
        if(Array.isArray(arrHasEvent) && arrHasEvent.length <= 7){
            arrHasEvent = [0,0,0,0,0,0,0].concat(arrHasEvent).concat([0,0,0,0,0,0,0]);
        }
        var weekDay = dateProperties.weekday;
        var year = dateProperties.year - 0;
        var month = dateProperties.month - 0;
        var day = dateProperties.day - 0;
        weekDay = weekDay===0? 7 : weekDay;
        var date = new Date(year,month-1,day);
        $weekDate = $('.week-date');
        $weekDate.each(function(index){
            var dist = index+1-weekDay-7;
            date.setFullYear(year,month-1,day+dist);
            var year1 = date.getFullYear();
            var month1 = date.getMonth() + 1;
            var day1 = date.getDate();
            $(this).data('date',year1+(month1<10?'0'+month1:''+month1)+(day1<10?'0'+day1:''+day1)).children().html(day1);
            if(Array.isArray(arrHasEvent)){
            if(arrHasEvent[index]){
                $(this).addClass('has-event');
                }
                else if(!isAppend){
                    $(this).removeClass('has-event');
                }
            }
            else{
                if(arrHasEvent[$(this).data('date')]){
                    $(this).addClass('has-event');
                }
                else if(!isAppend){
                $(this).removeClass('has-event');
                }
            }
            if($(this).data('date') == activeDate){
                $(this).addClass('active');
            }
            else{
                $(this).removeClass('active');
            }
        }).eq(notClick ? undefined : weekDay-1+7).click();
    }
    function updateSchedule(arrEvents){
		//alert("updateSchedule");
        typeof arrEvents == 'string'?arrEvents = JSON.parse(arrEvents):0;
		if(!Array.isArray(arrEvents)){
			arrEvents = [];
		}
        $timeLineLis.removeClass('has-event event-start event-end').find('.event-content').remove();
        var arrEvents1 = {};
        arrEvents.forEach(function(elem){
            if(arrEvents1[elem.classNum] === undefined){
                arrEvents1[elem.classNum] = [elem];
            }
            else{
                arrEvents1[elem.classNum].push(elem);
            }
        });
        arrEvents = [];
        for(var key in arrEvents1){
            if(arrEvents1.hasOwnProperty(key)){
                var tempElem,tempEndTime;
                arrEvents1[key].sort(function(elem1,elem2){
                    var startHour1 = elem1.startHour;
                    var startMinute1 = elem1.startMinute || 0;
                    var startHour2 = elem2.startHour;
                    var startMinute2 = elem2.startMinute || 0;
                    return startHour1 * 60 + startMinute1 - (startHour2 * 60 + startMinute2);
                }).forEach(function(elem,index,arr){
                    var endHour;
                    if(index == 0){
                        tempElem = elem;
                        endHour = elem.endHour;
                        endHour = endHour === undefined ? elem.startHour+1:endHour;
                        tempEndTime = endHour * 60 + (elem.endMinute || 0);
                    }
                    else{
                        var startHour = elem.startHour;
                        var startMinute = elem.startMinute || 0;
                        var startTime = startHour * 60 + startMinute;
                        if(startTime - tempEndTime < 20){
                            tempElem.endHour = elem.endHour;
                            tempElem.endMinute = elem.endMinute;
                            endHour = elem.endHour;
                            endHour = endHour === undefined ? elem.startHour+1:endHour;
                            tempEndTime = endHour * 60 + (elem.endMinute || 0);
							tempElem.site = tempElem.site || elem.site;
                        }
                        else{
                            arrEvents.push(tempElem);
                            tempElem = elem;
                            endHour = elem.endHour;
                            endHour = endHour === undefined ? elem.startHour+1:endHour;
                            tempEndTime = endHour * 60 + (elem.endMinute || 0);
                        }
                    }
                    if(index == arr.length-1){
                        arrEvents.push(tempElem);
                    }
                });
            }
        }
        arrEvents.forEach(function(elem){
            var startHour = elem.startHour;
            var endHour = elem.endHour;
            endHour = endHour === undefined ? startHour+1:endHour;
            var startMinute = elem.startMinute || 0;
            var endMinute = elem.endMinute || 0;
            var duration = (endHour+endMinute/60 - startHour - startMinute/60)*100;
            var $items = $timeLineLis.slice(startHour,endHour+(endMinute>0?1:0)),
                $item0 = $items.first(),
                $eventContainer = $item0.children('.event-container'),
                $event;
            switch (elem.type){
                case 1:
                    $event = $event1.clone().appendTo($eventContainer);
                    $items.addClass('has-event');
                    $item0.addClass('event-start');
                    $items.last().addClass('event-end');
                    $event.css('top',startMinute/60*100+'%');
                    $event.height(duration+'%');
                    $event.find('.event-title').html(elem.title);
                    $event.find('.event-class').html(elem.classNum);
                    $event.find('.event-site').html(elem.site);
                    $event.find('.event-cause').html(elem.cause);
					$event.click(function(){
                        if(window.Android){
                            Android.gotoDetail(elem.id, elem.endHour, elem.endMinute);
                        }
					});
                    break;
                case 2:
                    $event = $event2.clone().appendTo($eventContainer);
                    $items.addClass('has-event');
                    $item0.addClass('event-start');
                    $items.last().addClass('event-end');
                    $event.css('top',startMinute/60*100+'%');
                    $event.height(duration+'%');
                    $event.find('.event-title').html(elem.title);
                    $event.find('.event-rec').html(elem.recNum);
                    $event.find('.event-rej').html(elem.rejNum);
                    break;
                case 3:
                    $event = $event3.clone().appendTo($eventContainer);
                    $items.addClass('has-event');
                    $item0.addClass('event-start');
                    $items.last().addClass('event-end');
                    $event.css('top',startMinute/60*100+'%');
                    $event.height(duration+'%');
                    $event.find('.event-title').html(elem.title);
                    $event.find('.event-name').html(elem.name);
                    break;
            }
        });
        $(window).trigger('updateSchedule');
    }

    return {
        init: initVar,
        updateWeekDate:updateWeekDate,
        updateSchedule:updateSchedule
    };
});