/**
 * Created by Administrator on 2015/8/19.
 */
requirejs(['jquery','js/events.js','iscroll','calendario'],function($,events,IScroll){
    $(document).ready(function(){
        events.init();
        function getData(yearMonth,callBack){
            if(window.Android){
                var dayList = Android.isComplateMonth(yearMonth);
            }
            dayList = typeof dayList == 'string' ? JSON.parse(dayList) : dayList;
			if(!Array.isArray(dayList) || dayList.length < 1){
				dayList = [{
					date: [],
					month: yearMonth
				}];
			}
            callBack(dayList);
        }
        var refreshTimeoutId;
        var fCalendarSetData = function(elem,arrHasEvent){
            var $selfCalendar = $(elem);
            var yearMonth = $selfCalendar.data('yearmonth');
            var dateYear = yearMonth.substr(0,4), dateMonth = yearMonth.substr(4,2);
            var caldata = {};
            (arrHasEvent||[]).forEach(function(elem){
                var date = dateMonth + '-' + (elem<10?'0'+elem:elem) + '-' + dateYear;
                caldata[date] = '';
            });
            var calendar = $selfCalendar.data('calendar');
            if(calendar){
                    $selfCalendar.find('.fc-content').removeClass('fc-content').find('.fc-calendar-events').remove();
                calendar.setData(caldata);
                var $fcBody = calendar.$cal.children('.fc-body');
                $fcBody.children('.fc-row:first-child').clone().addClass('month-title').prependTo($fcBody).children().attr('class','fc-past')
                    .children('.fc-date').html('').first().html(calendar.getMonthName());
            }
            else{
                calendar = $selfCalendar.calendario({
                    year: dateYear-0,
                    month: dateMonth-0,
                    months:['一月','二月','三月','四月','五月','六月','七月','八月','九月','十月','十一月','十二月'],
                    startIn : 1,//从周一开始
                    fillEmpty: false,//不显示非本月日期
                    caldata: caldata,
                    onDayClick: function($el, $content, dateProperties){
                        if(isNaN(dateProperties.day-0)){
                            return;
                        }
                        var $ul = $('.calendar-week ul','.schedule-container');
                        events.updateWeekDate(dateProperties,[0,0,0,0,0,0,0]);
                        var yearMonths = [],arrHasEvent = {};
                        $ul.children('.week-date').each(function(){
                            var yearMonth = ($(this).data('date')+'').substr(0,6);
                            if(yearMonths.indexOf(yearMonth) == -1){
                                yearMonths.push(yearMonth);
                            }
                        });
                        yearMonths.forEach(function(elem){
                            getData(elem,function(dataList){
                                dataList.forEach(function(elem){
                                    var dataListElem = elem;
                                    dataListElem.date.forEach(function(elem){
                                        arrHasEvent[dataListElem.month+''+(elem<10?'0'+elem:elem)] = true;
                                            });
                                    });
                                events.updateWeekDate(dateProperties,arrHasEvent,true);
                                });
                        });
                        if(!isToToday && !isFarToToday && $calendarRight.hasClass('active')){
                            $('#swContent').click();
                        }
                    },
                    checkUpdate: false
                });
                $fcBody = calendar.$cal.children('.fc-body');
                $fcBody.children('.fc-row:first-child').clone().addClass('month-title').prependTo($fcBody).children().attr('class','fc-past')
                    .children('.fc-date').html('').first().html(calendar.getMonthName());
                $selfCalendar.data('calendar',calendar);
                initedLen++;
                if(initedLen == initLen){
                    $calendar.trigger('inited');
                }
            }
            return calendar;
        };

        var fInitCalendar = function(params){
			//alert("initCalendar");
            var date = new Date();
            typeof params == 'string'?params = JSON.parse(params):0;
			if(!Array.isArray(params)){
				params = [];
			}
            params.forEach(function(elem){
                var dateHasEvent = elem.date;
                var yearMonth = elem.month;
                $containers.filter(function(){return $(this).data('yearmonth') == yearMonth}).each(function(){
                    fCalendarSetData(this,dateHasEvent);
                });
            });
        };

        var iscrollCalendar;
        var isUpLoad = false, isDownLoad = false, isScroll = false;
        var onRefresh = {};
        var $calendarWrapper = $('#calendarWrapper');
        var $calendar =$('#calendar').one('inited',function(){
            var $selfCal = $(this);
            iscrollCalendar = new IScroll(this,{
                scrollbars: true,
                click: true,
                disableMouse: true,
                disablePointer: true,
                fadeScrollbars: true
            });
            iscrollCalendar.on('refresh',function(){
                for(var key in onRefresh){
                    if(onRefresh.hasOwnProperty(key)){
                        onRefresh[key] && onRefresh[key].apply(this);
                    }
                }
            });
            /*判断是否开始上拉或下拉*/
            iscrollCalendar.on('scrollStart',function(){
                isScroll = true;
                onRefresh.bottomLoaded = null;
                onRefresh.farToToday = null;
                if(this.y > -10 && this.directionY == -1){
                    $selfCal.addClass('up-loading-pad');
                    $calendarWrapper.addClass('add-padding-top');
                    clearTimeout(refreshTimeoutId);
                    refreshTimeoutId = setTimeout(function(){
                    iscrollCalendar.refresh();
                    },0);
                    isUpLoad = true;
                }
                if(this.y < this.maxScrollY+10 && this.directionY == 1){
                    $selfCal.addClass('down-loading-pad');
                    $calendarWrapper.addClass('add-padding-bottom');
                    clearTimeout(refreshTimeoutId);
                    refreshTimeoutId = setTimeout(function(){
                    iscrollCalendar.refresh();
                    },0);
                    isDownLoad = true;
                }
            });
            /*判断是否完成上拉或下拉，是则加载新内容*/
            iscrollCalendar.on('scrollEnd',function(){
                var dataMonth,$addCalendar;
                isScroll = false;
                if(isUpLoad){
                    isUpLoad = false;
                    if(this.y > -10){
                        dataMonth = $containers.first().data('yearmonth')-1;
                        if(dataMonth - Math.floor(dataMonth/100)*100 == 0){
                            dataMonth += (12-100);
                        }
                        dataMonth = dataMonth + '';
                        $addCalendar = $('<div>',{'class':'fc-calendar-container'})
                            .data('yearmonth',dataMonth).prependTo(this.scroller);
                        if($containers.length > 5){
                            $containers = $containers.not($containers.last().remove());
                        }
                        $containers = $([$addCalendar[0]].concat($containers.get()));
                        getData(dataMonth,fInitCalendar);
                    }
                        $selfCal.removeClass('up-loading-pad');
                    $calendarWrapper.removeClass('add-padding-top');
                    clearTimeout(refreshTimeoutId);
                    refreshTimeoutId = setTimeout(function(){
                        iscrollCalendar.refresh();
                    },0);
                }
                if(isDownLoad){
                    isDownLoad = false;
                    if(this.y < this.maxScrollY+10){
                        dataMonth = $containers.last().data('yearmonth')-0+1;
                        if(dataMonth - Math.floor(dataMonth/100)*100 > 12){
                            dataMonth += (100-12);
                        }
                        dataMonth = dataMonth + '';
                        $addCalendar = $('<div>',{'class':'fc-calendar-container'})
                            .data('yearmonth',dataMonth).appendTo(this.scroller);
                        if($containers.length > 5){
                            $containers = $containers.not($containers.first().remove());
                        }
                        $containers = $($containers.get().concat($addCalendar[0]));
                        getData(dataMonth,fInitCalendar);
                        onRefresh.bottomLoaded = function(){
                            this.scrollTo(0,this.maxScrollY);
                        };
                    }
                        $selfCal.removeClass('down-loading-pad');
                    $calendarWrapper.removeClass('add-padding-bottom');
                    clearTimeout(refreshTimeoutId);
                    refreshTimeoutId = setTimeout(function(){
                        iscrollCalendar.refresh();
                    },0);
                }
            });
            $('#todayBtn').click();
        });
        var $containers = $calendar.find('.fc-calendar-container');
        var initLen = $containers.length, initedLen = 0;
        var $todayContainer = $containers.filter('[data-month="0"]');
        var $todayNeighbor = $($containers).clone();

        var isToToday = false, isFarToToday = false;
        var scrollToToday = function(){
            if($containers.filter($todayContainer).length > 0){
                isToToday = true;
                iscrollCalendar.scrollToElement($todayContainer[0],100);
                $('.fc-today',$todayContainer).click();
                isToToday = false;
            }
            else{
                isFarToToday = true;
                isDownLoad = false;
                isUpLoad = false;
                $containers = $todayNeighbor;
                $(iscrollCalendar.scroller).html($todayNeighbor);
                $todayContainer = $containers.filter('[data-month="0"]');
                $containers.each(function(){
                    var date = new Date();
                    var distMonth = $(this).data('month');
                    date.setMonth(date.getMonth()+distMonth);
                    var dateMonth = date.getMonth()+1;
                    var yearMonth = date.getFullYear()+(dateMonth<10?'0'+dateMonth:''+dateMonth);
                    $(this).data('yearmonth',yearMonth);
                    getData($(this).data('yearmonth'),fInitCalendar);
                    //TODO: refresh
                });
                $('.fc-today',$todayContainer).click();
                onRefresh.farToToday = function(){
                    this.scrollToElement($todayContainer[0],100);
                };
                clearTimeout(refreshTimeoutId);
                refreshTimeoutId = setTimeout(function(){
                    iscrollCalendar.refresh();
                },0);
                isFarToToday = false;
            }
        };

        var $calendarRight = $('.calendar-container.right');
        $('#swContent').click(function(){
            if($calendarRight.hasClass('active')){
                $calendarRight.removeClass('active');
                $(this).removeClass('right');
            }
            else{
                $(this).addClass('right');
                $calendarRight.addClass('active');
                var date = new Date();
                if(!(date.getDate() == nowDate.getDate() && date.getMonth() == nowDate.getMonth() && date.getFullYear() == nowDate.getFullYear())){
                    nowDate = date;
                    $containers.empty().data('calendar',null);
                }
                $containers.each(function(){
                    getData($(this).data('yearmonth'),fInitCalendar);
                });
                clearTimeout(refreshTimeoutId);
                refreshTimeoutId = setTimeout(function(){
                    iscrollCalendar.refresh();
                },0);
            }
        });
        $('#todayBtn').click(scrollToToday);

        var iscrollSchedule = new IScroll('#schedule',{
            scrollbars: true,
            click: true,
            disableMouse: true,
            disablePointer: true,
            fadeScrollbars: true
        });
        var initTimeLi = $('.time-line > li','#schedule').get(7);
        /*日程表自动滚到有事件时间或者7点*/
        $(window).on('updateSchedule',function(){
            var domEvent0 = $('.has-event',iscrollSchedule.scroller).get(0);
            if(domEvent0 !== undefined){
                iscrollSchedule.scrollToElement(domEvent0,0,0,-10);
            }
            else{
                iscrollSchedule.scrollToElement(initTimeLi,0);
            }
        });
        var iscrollWeekDay = new IScroll('.calendar-week.scroll',{
            scrollX: true,
            scrollY: false,
            scrollbars: false,
            click: true,
            disableMouse: true,
            disablePointer: true,
            snap: 'ul'
        });
        iscrollWeekDay.on('scrollEnd',function(){
            var $ul = $(this.scroller).find('ul');
            if(this.currentPage.pageX === 0){
                $ul.last().insertBefore($ul.first());
            }
            else if(this.currentPage.pageX === 2){
                $ul.first().insertAfter($ul.last());
            }
            $ul = $(this.scroller).find('ul');
            var refDate = $ul.eq(1).children('.week-date').data('date')+'';
            events.updateWeekDate(refDate,[0,0,0,0,0,0,0],true);
            var yearMonths = [],arrHasEvent = {};
            $ul.children('.week-date').each(function(){
                var yearMonth = ($(this).data('date')+'').substr(0,6);
                if(yearMonths.indexOf(yearMonth) == -1){
                    yearMonths.push(yearMonth);
                }
            });
            yearMonths.forEach(function(elem){
                getData(elem,function(dataList){
                    dataList.forEach(function(elem){
                        var dataListElem = elem;
                        dataListElem.date.forEach(function(elem){
                            arrHasEvent[dataListElem.month+''+(elem<10?'0'+elem:elem)] = true;
                        });
                    });
                    events.updateWeekDate(refDate,arrHasEvent,true);
                });
            });
            iscrollWeekDay.goToPage(1,0,0);
        });
        iscrollWeekDay.goToPage(1,0,0);
        var nowDate = new Date();
		//$('<div id="testt">').html('start ').css({position:'absolute',top:'0',left:'0'}).appendTo('body');
		window.init = function(){
			nowDate = new Date();
			$containers.each(function () {
				var date = new Date();
				var distMonth = $(this).data('month');
				date.setMonth(date.getMonth()+distMonth);
				var dateMonth = date.getMonth()+1;
				var yearMonth = date.getFullYear()+(dateMonth<10?'0'+dateMonth:''+dateMonth);
				$(this).data('yearmonth',yearMonth);
				getData(yearMonth,fInitCalendar);
			});
			refreshTimeoutId = setTimeout(function(){iscrollCalendar.refresh();},0);
		}
		initJS();
    });
});
var isComplate = false;
function initJS(){
	if(isComplate){
		window.init();
	}
	isComplate = true;
}
