/**
 * Created by Administrator on 2014/12/23.
 * 最后编辑：吴青龙
 * 功能：倒计时
 * 属性和方法：初始化参数和默认值：
 *              T({
 *                  startTime: 3600,
 *                  timeOverDialog: false,
 *                  dialogId: 'timeOver',
 *                  timeDivID: 'RecordTime',
 *                  buttonID: 'btn-hid',
 *                  onRun: function() {},
 *                  onStart: function() {},
 *                  onOver: function(){}
 *              });
 *             对象属性：
 *             T.ele-HTML元素对象，时间显示HTML元素对象；
 *             T.currentTime-字符串，剩余时间字符串；
 *             T.currentTime.h/m/s-数字，剩余时间时/分/秒；
 *             对象方法：
 *             T.addListener('run',function() {});--添加事件回调函数，run正在计时（循环运行）、ready正在计时（仅运行一次）、over倒计时结束;
 *             T.removeListener('run',function handler);--移除事件响应，第二个参数为回调函数变量;
 *TODO: 可用new T(0创建倒计时对象
// */

define(['jquery','js/storage.js'],function($,ST) {
    var initTime;/*初始时间*/
    var bOverDialog, sOverDialogId;/*时间结束弹出窗口*/
    var $Button;/*显示隐藏时间按钮*/
    var $timeDiv;/*显示时间的HTML元素*/
    var setIntervalId;/*用于倒计时的定时运行ID*/
    var oReturn;
    var $timeOver;/*时间结束提示框*/
    var pause = false;/*暂停标志*/
    var bIsShow;/*当前状态是否为显示时间*/
    var oThisObj;/*倒计时对象，可用new T(objInit)创建不同对象*/
    var over = false;/*TODO: DEBUG*/
    var isCountdown = false;
    var isStorage = false;
    var fInit = function(objInit,val) {
        if(this instanceof fInit) {/*判断使用new T(objInit)初始化还是T(objInit)初始化，以绑定this对象*/
            oThisObj = this;
            oThisObj.prototype = fInit;
        }
        else {
            oThisObj = fInit;
        }
        if(typeof objInit == 'object' && !Array.isArray(objInit)) {/*初始化*/
            clearInterval(setIntervalId);
            /*移除原倒计时，以便初始化新的倒计时*/
            var storageTime = isStorage ? ST('mockTime') : undefined;
            storageTime = storageTime === '' || storageTime === null ? undefined : storageTime;
            storageTime = typeof storageTime !== 'string' && typeof storageTime !== 'number' ? undefined : storageTime;
            initTime = storageTime ? storageTime-0 : objInit.startTime-0;
            initTime = isNaN(initTime) ? (isCountdown ? 3600 : 0) : initTime;
            bOverDialog = objInit.timeOverDialog ? true : false;
            sOverDialogId = objInit.dialogSel || '#ui-dialog-time-over';
            $Button = $(objInit.btnElem);
            $timeDiv = $(objInit.timeElem);
            isCountdown = objInit.isCountdown || false;
            isStorage = objInit.isStorage || false;
            pause = objInit.isAutoRun === false;
            typeof objInit.onRun == 'function' ? addListener('run', objInit.onRun) : 0;
            typeof objInit.onReady == 'function' ? addListener('ready', objInit.onReady) : 0;
            typeof objInit.onOver == 'function' ? addListener('over', objInit.onOver) : 0;
            setTimeout(timeCounter.bind(oThisObj),200);/*延迟200ms开始倒计时,让其他初始化有足够时间完成*/
            $Button.click(function() {/*为按钮添加点击事件*/
                if($timeDiv.css('display') == 'none'){
                    $timeDiv.show();
                    if(window.navigator.userAgent.indexOf("Chrome") !== -1)
                        $(this).html('<span style="display:inline-block;-webkit-transform: scale(0.8)">HIDE&nbsp;TIME</span>');
                    else
                        $(this).html('HIDE TIME');
                    bIsShow = true;
                }else{
                    $timeDiv.hide();
                    if(window.navigator.userAgent.indexOf("Chrome") !== -1)
                        $(this).html('<span style="position:relative;left:-4px;display:inline-block;-webkit-transform: scale(0.75)">SHOW&nbsp;TIME</span>');
                    else
                        $(this).html('SHOW TIME');
                    bIsShow = false;
                }
            });
        }
        else if(typeof objInit == 'string') {/*设置变量值*/
            switch(objInit) {
                case 'bOverDialog':
                    bOverDialog  = val == true ? true : (val == false ? false : bOverDialog);
                    break;
                case 'pause':
                    pause = val == true ? true : (val == false ? false : pause);
            }
        }
        return fInit;
    };

    var onRunHandle = [];
    var onOverHandle = [];
    var onReadyHandle = [];
    onReadyHandle.state = [];
    onOverHandle.state = [];
    var addListener = function(sEvent,fCallBack) {
        switch(sEvent) {
            case 'run':
                onRunHandle.push(fCallBack);
                break;
            case 'ready':
                onReadyHandle.push(fCallBack);
                onReadyHandle.state.push(true);
                break;
            case 'over':
                onOverHandle.push(fCallBack);
                onOverHandle.state.push(true);
                break;
        }
        return fInit;
    };
    var removeListener = function(sEvent,fHandle) {
        var onHandle;
        switch(sEvent) {
            case 'run':
                onHandle = onRunHandle;
                break;
            case 'ready':
                onHandle = onReadyHandle;
                break;
            case 'over':
                onHandle = onOverHandle;
                break;
        }
        if(onHandle != undefined) {
            if(fHandle == undefined)
                onHandle.splice(0);
            else if(typeof fHandle == 'function') {
                onHandle.splice(onHandle.indexOf(fHandle),1);
                if(onHandle === onReadyHandle || onHandle === onOverHandle) {
                    var onHandleSt = onHandle.state;
                    onHandleSt.splice(onHandle.indexOf(fHandle));
                }
            }
        }
        return fInit;
    };

    var fOver = function () {
        clearInterval(setIntervalId);
        clearTimeout(setIntervalId);
        ST.reset('mockTime');
        onOverHandle.forEach(function(ele,index) {
            if(onOverHandle.state[index] == true) {
                ele();
                onOverHandle.state[index] = false;
            }
        });
    };

//计时
    var total = 0;
    var timeCounter = function() {
        if(typeof initTime == 'number') {/*判断是否属于初始化*/
            total = initTime;
            clearInterval(setIntervalId);
            clearTimeout(setIntervalId);
            setIntervalId = setInterval(timeCounter.bind(this),1000);
            initTime = undefined;
            onReadyHandle.state.map(function() {return true});/*初始化所有ready事件的回调函数为未运行状态*/
            onOverHandle.state.map(function() {return true});/*初始化所有over事件的回调函数为未运行状态*/
        }
        if(over == true) total = 0;/*TODO: DEBUG*/
        if(total >= 0) {
            var s = (total % 60) < 10 ? ('0' + total % 60) : total % 60;
            var h = total / 3600 < 10 ? ('0' + parseInt(total / 3600)) : parseInt(total / 3600);
            var m = (total - h * 3600) / 60 < 10 ? ('0' + parseInt((total - h * 3600) / 60)) : parseInt((total - h * 3600) / 60);
            this.currentTime = h + ':' + m + ':' + s;
            $timeDiv.length > 0 ? $timeDiv.html(this.currentTime) : 0;
            this.currentS = Number(s);
            this.currentH = Number(h);
            this.currentM = Number(m);
            this.overTime = 0;
            onReadyHandle.forEach(function (ele, index) {
                if (onReadyHandle.state[index] == true) {
                    ele();
                    onReadyHandle.state[index] = false;
                }
            });
            if(pause == false) {
                onRunHandle.forEach(function (ele) {
                    ele();
                });
                ST('mockTime',total);
                isCountdown ? total-- : total++;
            }
        }
        if(total < 0 && pause == false) {/*判断是否已结束*/
            clearInterval(setIntervalId);
            oReturn.overTime = 1;
            if(bOverDialog && $timeOver == undefined)
                fOverDialog();
            else if(!bOverDialog)
                fOver();
            setIntervalId = setTimeout(timeCounter.bind(this),100);/*倒计时结束后仍能继续运行处理函数，如over时间响应*/
        }
    };

    function fOverDialog() {
        var sFinalSection = $('form > input[name="finalSection"]').val();
        $timeOver = $(sOverDialogId).filter(function() {
            return String($(this).data('finalsection')).split(' ').indexOf(String(sFinalSection)) != -1
        });
        if($timeOver.length > 0)
            requirejs(['jquery-ui'], function () {
                /*初始化弹出对话框，并显示，提示时间已结束*/
                $timeOver.css({position:'absolute'});
                var s = $timeOver.height() * $timeOver.width();
                $timeOver.css({position:''});
                var wph = 1.8;
                var b = 132 * wph - 30, c = s * wph;
                var nWidth = (b + Math.sqrt(b * b + 4 * c))/2 + 30;
                var sBtnOK = $timeOver.data('button-ok') || '确定';
                $timeOver.dialog({
                    resizable: false,
                    autoOpen: true,
                    width: nWidth,
                    buttons: [
                        {text: sBtnOK, click: fOver}
                    ],
                    close: fOver,
                    hide: 300,
                    show: 300,
                    modal: true,
					draggable: false
                });
            });
        else
            fOver();
    }

    oReturn = fInit;
    oReturn.addListener = addListener;
    oReturn.removeListener = removeListener;
    oReturn.pause = function() {return fInit('pause',true)};
    oReturn.run = function() {return fInit('pause',false)};
    oReturn.over = function() {over = true};/*TODO: DEBUG*/
    return oReturn;
});
