var iOS;
function connectWebViewJavascriptBridge(callback) {
	if (window.WebViewJavascriptBridge) {
		callback(WebViewJavascriptBridge)
	} else {
		document.addEventListener('WebViewJavascriptBridgeReady', function() {
			callback(WebViewJavascriptBridge)
		}, false)
	}
}
/**
 * 说明：
 * APP初始化完毕调用window.init(initOrder),initOrder表示初始题目序号
 * 暂停时间调用window.pause()
 * 继续计时调用window.run()
 */
var storageData = null;
function getData(questionOrder,callBack){
    if(!storageData){
        //TODO: 此处获取数据
		if(window.Android){
			dataStorage(Android.getTestData(),Android.getAnswers());
			initData(questionOrder,callBack);
		}else if(iOS){
			iOS.callHandler('getData', "", function (response) {
				dataStorage(response.testData,response.answers);
				initData(questionOrder,callBack);
			})
                            }
    }else {
		initData(questionOrder,callBack);
                        }
                                }
function initData(questionOrder,callBack){
	var index = 0;
    if(questionOrder===null){
		storageData.data.some(function(elem,index0){
            index = index0;
			return elem.answer.answer === null || !(elem.answer.answer >=0);
		});
    }
    else{
        index = questionOrder - 1;
    }
    callBack(storageData.data[index],storageData.data);
}
function postData(questionOrder,isSubmit){
// answers: 答案数组,形如['A',undefined,'C','D']
    var postData = JSON.stringify(storageData.data[questionOrder-1].answer);

	if(window.Android){
		Android.saveData(postData, isSubmit == true);
	}else if(iOS){
		iOS.callHandler('saveData', {postData: storageData.data[questionOrder-1].answer, isSubmit: isSubmit == true, questionNum: questionNum}, function (response) {})
    }
}
function dataStorage(data,answers){
    data = typeof data == 'string' ? JSON.parse(data) : data;
    answers = typeof answers == 'string' ? JSON.parse(answers) : answers;
    storageData = {};
    if(data.State == 0){
        alert(data.Error);
        return {};
    }
    else{
        if(data.DataCount < 1){
            alert('无数据');
            return {};
        }
        else{
            var minInd = 0;
            storageData.info = {questionNum:0,perType: []};
            (data.Data.paper.list_composition || []).forEach(function(elem){
                var maxInd = minInd+(elem.question_num-1);
                storageData.info.perType.push({
                    type: elem.question_type,
                    range: [minInd,maxInd]
                });
                minInd = maxInd+1;
            });
            storageData.info.questionNum = minInd;
            storageData.data = [];
            var questionOrder = 1;
            (data.Data.list || []).forEach(function(elem){
                elem.paperQuestions.forEach(function(elem){
                    if(elem.question.questions === null){
                        var dataObj = {
                            type: elem.question_type,
                            questionNum: minInd,
                            questionOrder: questionOrder,
                            question: elem.question.subject_content,
                            options: elem.question.options.map(function(elem){
                                return elem.option_desc;
                            }),
                            "score": elem.score,
                            answer: {
                                "exam_id": data.Data.exam_id,
                                "question_id": elem.question_id,
                                "paper_id": elem.paper_id,
                                "test_id": null,
                                "enter_time": elem.enter_time,
                                "state_time": null,
                                "answer": null,
                                "right_answer": elem.question.answer.answer,
                                "score": null,
                                "question_type": elem.question_type
                            }
                        };
                        var answerElem = answers.filter(function(ansElem){
                            return ansElem.exam_id == dataObj.answer.exam_id &&
                                ansElem.question_id == dataObj.answer.question_id &&
                                ansElem.paper_id == dataObj.answer.paper_id;
                        })[0];
                        if(answerElem){
							answerElem.answer = answerElem.answer === ''? null : answerElem.answer;
                            dataObj.answer = answerElem;
                        }
                        storageData.data.push(dataObj);
                        questionOrder++;
                    }
                    else{
                        var passageElem = elem, subNum = elem.question.questions.length;
                        elem.question.questions.forEach(function(elem,index){
                            var dataObj = {
                                type: passageElem.question_type,
                                subType: elem.question_type,
                                questionNum: minInd,
                                questionOrder: questionOrder,
                                subNum: subNum,
                                subOrder: index+1,
                                passage: passageElem.question.subject_content,
                                question: elem.subject_content,
                                options: elem.options.map(function(elem){
                                    return elem.option_desc;
                                }),
                                "score": passageElem.score,
                                answer: {
                                    "exam_id": data.Data.exam_id,
                                    "question_id": elem.answer.question_id,
                                    "paper_id": passageElem.paper_id,
                                    "test_id": null,
                                    "enter_time": elem.enter_time,
                                    "state_time": null,
                                    "answer": null,
                                    "right_answer": elem.answer.answer,
                                    "score": null,
                                    "question_type": elem.question_type
                                }
                            };
                            var answerElem = answers.filter(function(ansElem){
                                return ansElem.exam_id == data.Data.exam_id &&
                                    ansElem.question_id == elem.answer.question_id &&
                                    ansElem.paper_id == passageElem.paper_id;
                            })[0];
                            if(answerElem){
								answerElem.answer = answerElem.answer === ''? null : answerElem.answer;
                                dataObj.answer = answerElem;
                            }
                            storageData.data.push(dataObj);
                            questionOrder++;
                        });
                    }
                });
            });
        }
    }
    return storageData;
}
var questionNum;
requirejs(['jquery','iscroll', 'js/count_time.js','js/update_question.js'],function($,Scroll,T,update) {
    var questionOrder;
    var updateQuestion = function (data) {
        update.generate(data);

        var $options = update.getOptions();
        var $nav = update.getNav();
        questionOrder = data.questionOrder;
        /*选中答案*/
        $options.click(function () {
            $(this).addClass('selected').siblings('.selected').removeClass('selected');
            data.answer.answer = $.trim($(this).find('.item-order i').text()).charCodeAt(0) - 65;
            $nav.eq(questionOrder - 1).addClass('success');
            if (data.answer.right_answer !== null && data.answer.answer === (data.answer.right_answer - 0)) {
                data.answer.score = data.score;
            }
            else {
                data.answer.score = 0;
            }
        });
        /*设置已选选项*/
        if (data.answer.answer !== null) {
            $options.eq(data.answer.answer - 0).addClass('selected');
        }

        /*更新"上一题""下一题"按钮可用状态*/
        if (questionOrder > 1) {
            $preBtn.removeClass('disabled');
        }
        if (questionOrder < questionNum) {
            $nextBtn.removeClass('submit');
            $submitBtn.removeClass('submit');
        }
        if (questionOrder == 1) {
            $preBtn.addClass('disabled');
        }
        if (questionOrder == questionNum) {
            $nextBtn.addClass('submit');
            $submitBtn.addClass('submit');
        }
    };
    var initQuestion = function (data, dataAttr) {
        update.init(data, dataAttr);
        /*获取题数*/
        questionNum = data.questionNum;
        /*设置题目导航*/
        var $nav = update.getNav();
        $nav.click(function () {
            $('#navBtn').click();
            update.exit();
            postData(questionOrder);
            questionOrder = $nav.index(this) + 1;
            getData(questionOrder, updateQuestion);
        });
        /*更新题目其他内容*/
        updateQuestion(data);
        if (window.Android) {
            T({
                startTime: (function () {
                    return Android.getUseTime();
                })(),
                isAutoRun: true,
                timeElem: '#clock'/*显示时间的HTML元素*/
            });
        } else if (iOS) {
            iOS.callHandler('getUseTime', "", function (response) {
                T({
                    startTime: response,
                    isAutoRun: true,
                    timeElem: '#clock'/*显示时间的HTML元素*/
                });
            })
        } else {
            T({
                startTime: 0,
                isAutoRun: true,
                timeElem: '#clock'/*显示时间的HTML元素*/
            });
        }
    };

    var $quesNavWrapper = $('.question-nav');
    var $quesNavContainer = $quesNavWrapper.children('.nav-container');
    var $quesNav = $quesNavContainer.children('nav');
    var isShown = false;
    /*显示隐藏题目导航*/
    $('#navBtn').click(function () {
        if (isShown) {
            $quesNavWrapper.removeClass('myshow').addClass('myhide');
            $quesNavContainer.height(0);
            isShown = false;
        }
        else {
            $quesNavWrapper.removeClass('myhide').addClass('myshow');
            var temp = $quesNav.css('height');
            $quesNavContainer.height(temp);
            isShown = true;
        }
    });
    $quesNavWrapper.children('.mymodal').click(function () {
        $('#navBtn').click();
    });

    /*上一题和下一题操作*/
    var $preBtn = $('#preBtn').click(function () {
        if (questionOrder > 1) {
            update.exit();
            postData(questionOrder);
            questionOrder--;
            getData(questionOrder, updateQuestion);
        }
    });
    var $nextBtn = $('#nextBtn').click(function () {
        if (questionOrder < questionNum) {
            update.exit();
            postData(questionOrder);
            questionOrder++;
            getData(questionOrder, updateQuestion);
        }
    });
    var $submitBtn = $('#submitBtn').click(function () {
        update.exit();
        postData(questionOrder, true);
    });


    /*APP初始化完成后运行,参数initOrder表示初始题目序号,不带参数则默认为1*/
    window.init0 = function (initOrder) {
        getData(null, initQuestion);
        T.run();
    };
    /*时间暂停*/
    window.pause = function () {
        T.pause();
    };
    /*时间继续*/
    window.run = function () {
        T.run();
    };
    if (isComplate) {
        window.init0();
    }
    isComplate = true;

    connectWebViewJavascriptBridge(function (bridge) {
        iOS = bridge;
        bridge.init(function (message, responseCallback) {
            log('JS got a message', message)
            var data = { 'Javascript Responds': 'Wee!' }
            log('JS responding with', data)
            responseCallback(data)
        });

        bridge.registerHandler('initJS', function (data, responseCallback) {
            window.init0();
        });

        bridge.registerHandler('pause', function (data, responseCallback) {
            window.pause();
        });

        bridge.registerHandler('run', function (data, responseCallback) {
            window.run();
        });
    })
});
var isComplate = false;
function init() {
    if (isComplate) {
        window.init0();
    }
    isComplate = true;
}

