/**
 * Created by Administrator on 2015/9/7.
 */
var iOS;
function connectWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        callback(WebViewJavascriptBridge)
    } else {
        document.addEventListener('WebViewJavascriptBridgeReady', function () {
            callback(WebViewJavascriptBridge)
        }, false)
    }
}
/**
 * 说明：
 * APP初始化完毕调用window.init(initOrder),initOrder表示初始题目序号
 * 暂停时间调用window.pause()
 * 继续计时调用window.run()
 */
var storageData = null;
function getData(questionOrder,callBack){
// questionOrder表示请求的题目序号
// callBack是获得数据后的回调函数
    if(!storageData){
        //TODO: 此处获取数据
		if(window.Android){
			dataStorage(Android.getTestData(), Android.getTestReport(), Android.getUserName());
			initData(questionOrder,callBack);
		}else if (iOS) {
			iOS.callHandler('getData', "", function (response) {
				dataStorage(response.testData, response.testReport, response.userName);
				initData(questionOrder,callBack);
			})
                            }
    }else {
		initData(questionOrder,callBack);
                        }
                                }
function initData(questionOrder,callBack) {
    var index;
    if (questionOrder === null) {
        if (!storageData.data.some(function (elem, index0) {
            index = index0;
            return elem.answer.state_time === null;
        })) {
            index = 0;
        }
    }
    else if (typeof questionOrder == 'number') {
        index = questionOrder - 1;
    }
    else {
        index = questionOrder
    }
    callBack(storageData.data[index], storageData.data);
}
function postData(isSubmit) {
// answers: 答案数组,形如['A',undefined,'C','D']
    var postData = JSON.stringify(storageData.data.map(function (elem) {
        return elem.answer;
    }));
    if (isSubmit) {
        console.log(postData);
        alert('posted: ' + postData);
    }
}
function dataStorage(detail,report,userName) {
    var data = typeof detail == 'string' ? JSON.parse(detail) : detail;
    var dataReport = typeof report == 'string' ? JSON.parse(report) : report;
    storageData = {};
    if (data.State == 0 || dataReport.State == 0) {
        alert(data.Error || dataReport.Error);
        return {};
    }
    else {
        if (data.DataCount < 1 || dataReport.DataCount < 1) {
            alert('无数据');
            return {};
        }
        else {
            storageData.data = [];
            var questionOrder = 1;
            (data.Data.list || []).forEach(function (elem) {
                elem.paperQuestions.forEach(function (elem) {
                    if (elem.question.questions === null) {
                        var dataObj = {
                            type: elem.question_type,
                            questionOrder: questionOrder,
                            question: elem.question.subject_content,
                            options: elem.question.options.map(function (elem) {
                                return elem.option_desc;
                            }),
                            "score": elem.score,
                            answer: {},
                            userAnswer: elem.question.myAnswer.answer !== null && elem.question.myAnswer.answer !== '' ? String.fromCharCode(elem.question.myAnswer.answer - 0 + 65) : null,
                            correctAnswer: String.fromCharCode(elem.question.myAnswer.right_answer - 0 + 65),
                            time: (function () {
                                var temp = dataReport.Data.finished_time_count;
                                var hour = Math.floor(temp / 60 / 60);
                                temp = temp - hour * 60 * 60;
                                var min = Math.floor(temp / 60);
                                temp = temp - min * 60;
                                var sec = Math.round(temp);
                                return (hour >= 10 ? hour : '0' + hour) + ':' + (min >= 10 ? min : '0' + min) + ':' + (sec >= 10 ? sec : '0' + sec);
                            })(),
                            userTime: (function () {
                                var min = Math.floor(elem.question.myAnswer.state_time / 60);
                                var sec = Math.round(elem.question.myAnswer.state_time - min * 60);
                                return (min > 0 ? min + '分' : '') + sec + '秒';
                            })(),
                            averageTime: (function () {
                                var min = Math.floor(elem.question.myAnswer.avgUseTime / 60);
                                var sec = Math.round(elem.question.myAnswer.avgUseTime - min * 60);
                                return (min > 0 ? min + '分' : '') + sec + '秒';
                            })(),
                            correctRate: elem.question.myAnswer.avgRightRate,
                            detail: elem.question.answer.analysis
                        };
                        storageData.data.push(dataObj);
                        questionOrder++;
                    }
                    else {
                        var passageElem = elem, subNum = elem.question.questions.length;
                        elem.question.questions.forEach(function (elem, index) {
                            var dataObj = {
                                type: passageElem.question_type,
                                subType: elem.question_type,
                                questionOrder: questionOrder,
                                subNum: subNum,
                                subOrder: index + 1,
                                passage: passageElem.question.subject_content,
                                question: elem.subject_content,
                                options: elem.options.map(function (elem) {
                                    return elem.option_desc;
                                }),
                                "score": passageElem.score,
                                answer: {},
                                userAnswer: elem.myAnswer.answer !== null && elem.myAnswer.answer !== '' ? String.fromCharCode(elem.myAnswer.answer - 0 + 65) : null,
                                correctAnswer: String.fromCharCode(elem.myAnswer.right_answer - 0 + 65),
                                time: (function () {
                                    var temp = dataReport.Data.finished_time_count;
                                    var hour = Math.floor(temp / 60 / 60);
                                    temp = temp - hour * 60 * 60;
                                    var min = Math.floor(temp / 60);
                                    temp = temp - min * 60;
                                    var sec = Math.round(temp);
                                    return (hour >= 10 ? hour : '0' + hour) + ':' + (min >= 10 ? min : '0' + min) + ':' + (sec >= 10 ? sec : '0' + sec);
                                })(),
                                userTime: (function () {
                                    var min = Math.floor(elem.myAnswer.state_time / 60);
                                    var sec = Math.round(elem.myAnswer.state_time - min * 60);
                                    return (min > 0 ? min + '分' : '') + sec + '秒';
                                })(),
                                averageTime: (function () {
                                    var min = Math.floor(elem.myAnswer.avgUseTime / 60);
                                    var sec = Math.round(elem.myAnswer.avgUseTime - min * 60);
                                    return (min > 0 ? min + '分' : '') + sec + '秒';
                                })(),
                                correctRate: elem.myAnswer.avgRightRate,
                                detail: elem.answer.analysis
                            };
                            storageData.data.push(dataObj);
                            questionOrder++;
                        });
                    }
                });
            });
            storageData.data.forEach(function (elem, index, arr) {
                elem.questionNum = arr.length;
            });
            storageData.data['report'] = {
                userName: userName,
                userScore: dataReport.Data.score - 0,
                totalScore: dataReport.Data.paperScore,
                averageScore: dataReport.Data.averageScore,
                questionNum: dataReport.Data.question_num,
                rankPercent: dataReport.Data.defeatRate,
                rank: 'x',
                rankMax: 'x',
                timeActual: (function () {
                    var min = Math.floor(dataReport.Data.finished_time_count / 60);
                    var sec = Math.round(dataReport.Data.finished_time_count - min * 60);
                    return (min > 0 ? min + '分' : '') + sec + '秒';
                })(),
                timeAverage: (function () {
                    var min = Math.floor(dataReport.Data.avgUseTime / 60);
                    var sec = Math.round(dataReport.Data.avgUseTime - min * 60);
                    return (min > 0 ? min + '分' : '') + sec + '秒';
                })(),
                timeDemand: (function () {
                    var min = Math.floor(dataReport.Data.test_time / 60);
                    var sec = Math.round(dataReport.Data.test_time - min * 60);
                    return (min > 0 ? min + '时' : '') + sec + '分';
                })()
            };
        }
    }
    return storageData;
}
requirejs(['jquery','iscroll', 'js/update_question.js'],function($,Scroll,update) {
    $(document).ready(function () {
        var userAnswer, CorrectAns, questionNum, questionOrder;
        var updateQuestion = function (data) {
            update.generate(data);

            var $template = update.getAll();
            var $options = update.getOptions();
            questionOrder = data.questionOrder;
            userAnswer = data.userAnswer;
            CorrectAns = data.correctAnswer;
            /*设置已选选项*/
            userAnswer && $options.eq(userAnswer.charCodeAt(0) - 65).addClass('selected');
            $options.eq(CorrectAns.charCodeAt(0) - 65).addClass('correct');
            /*设置summary*/
            var $userAns = $('.user-answer', $template).text(userAnswer || '未答');
            if (userAnswer != CorrectAns) {
                $userAns.parent().addClass('warning');
            }
            $('.correct-answer', $template).text(CorrectAns);
            $('.user-time', $template).text(data.userTime);
            $('.average-time', $template).text(data.averageTime);
            $('.correct-rate', $template).text(data.correctRate);
            $('#clock').text(data.time);
            /*设置detail*/
            $('.detail-text', $template).html(data.detail);

            setTimeout(function () {
                var passageScroller = update.getObj('passageScroller');
                var subjectScroller = update.getObj('subjectScroller');
                passageScroller && passageScroller.refresh();
                subjectScroller && subjectScroller.refresh();
            });

            /*更新"上一题""下一题"按钮可用状态*/
            if (questionOrder > 1) {
                $preBtn.removeClass('disabled');
            }
            if (questionOrder < questionNum) {
                $nextBtn.removeClass('disabled');
            }
            if (questionOrder == 1) {
                $preBtn.addClass('disabled');
            }
            if (questionOrder == questionNum) {
                $nextBtn.addClass('disabled');
            }
        };
        var initQuestion = function (data, dataArr) {
            update.init(data, dataArr);
            /*获取题数*/
            questionNum = data.questionNum;
            /*设置题目导航*/
            var $nav = update.getNav();
            $nav.click(function () {
                $('#navBtn').click();
                questionOrder = $nav.index(this) + 1;
                $(this).addClass('success').siblings().removeClass('success');
                getData(questionOrder, updateQuestion);
            }).first().addClass('success');
            /*更新题目其他内容*/
            updateQuestion(data);
        };


        var $quesNavWrapper = $('.question-nav');
        var $quesNavContainer = $quesNavWrapper.children('.nav-container');
        var $quesNav = $quesNavContainer.children('nav');
        var isShown = false;
        /*显示隐藏题目导航*/
        $('#navBtn').click(function () {
            if (isShown) {
                $quesNavWrapper.removeClass('myshow').addClass('myhide');
                $quesNavContainer.height(0);
                isShown = false;
            }
            else {
                $quesNavWrapper.removeClass('myhide').addClass('myshow');
                $quesNavContainer.height($quesNav.css('height'));
                isShown = true;
            }
        });
        $quesNavWrapper.children('.mymodal').click(function () {
            $('#navBtn').click();
        });

        /*上一题和下一题操作*/
        var $preBtn = $('#preBtn').click(function () {
            if (questionOrder > 1) {
                questionOrder--;
                $quesNav.find('a').eq(questionOrder - 1).addClass('success').siblings().removeClass('success');
                getData(questionOrder, updateQuestion);
            }
        });
        var $nextBtn = $('#nextBtn').click(function () {
            if (questionOrder < questionNum) {
                questionOrder++;
                $quesNav.find('a').eq(questionOrder - 1).addClass('success').siblings().removeClass('success');
                getData(questionOrder, updateQuestion);
            }
        });

        var updateReport = function (data) {
            $('.js-userScore').text(data.userScore);
            $('#totalScore').text(data.totalScore);
            $('#scoreAverage').text(data.averageScore);
            $('#quesNum').text(data.questionNum);
            $('#msg').text(data.userName + '，你击败了' + data.rankPercent + '的同学哦~');
            //$('#rank').html('排名第'+data.rank+'<span class="rank-max">/'+data.rankMax+'</span>');
            $('#rank').html('');
            $('#timeActual').text(data.timeActual);
            $('#timeAverage').text(data.timeAverage);
            $('#timeDemand').text(data.timeDemand);
        };

        $('#reportSw').click(function () {
            getData('report', updateReport);
            $(this).addClass('active').siblings().removeClass('active');
            $('#reportPage').removeClass('hidden');
            $('#detailPage').addClass('hidden');
        });
        $('#detailSw').one('click', function () {
            getData(1, initQuestion);
        }).click(function () {
            $(this).addClass('active').siblings().removeClass('active');
            $('#reportPage').addClass('hidden');
            $('#detailPage').removeClass('hidden');
        });

        /*APP初始化完成后运行,参数initOrder表示初始题目序号,不带参数则默认为1*/
        window.init = function (initOrder) {
            getData('report', updateReport);
        };
        initJS();

        connectWebViewJavascriptBridge(function (bridge) {
            iOS = bridge;
            bridge.init(function (message, responseCallback) {
                log('JS got a message', message)
                var data = { 'Javascript Responds': 'Wee!' }
                log('JS responding with', data)
                responseCallback(data)
            })

            bridge.registerHandler('initJS', function (data, responseCallback) {
                window.init();
            })
        })
    });
});
var isComplate = false;
function initJS() {
    if (isComplate) {
        window.init();
    }
    isComplate = true;
}

